.include "tn13def.inc"
.device ATtiny13
; Fuse:	  |  high |  |  low  |
;		  1111 1111  0110 1010
;		  1111 1111  0111 1010 ClkDiv8 - Disable

.equ	osc	=	9600000	;   Hz
;**********  Variables  ************* 
.include "PWM_Key_Led_Var.asm"
;********  End Variables  ***********
.CSEG
.org 0
	rjmp	begin					;
	reti    ;rjmp	Ext_INT0	; External Interrupt Request 0
	reti	;rjmp	PCh_INT0		; Pin Change Interrupt (PCI)
	rjmp	Tim0_OVF		; Timer/Counter0 Overflow
	reti	;rjmp	EERDY			; EEPROM Ready
	reti	;rjmp	ACI				; Analog Comparator
	reti	;rjmp	Tim0_CompA		; Timer/Counter0 Compare Match A
	reti	;rjmp	Tim0_CompB		; Timer/Counter0 Compare Match B
	reti	;rjmp	WDT				; Watchdog Timer Overflow
	reti	;rjmp	ADCC			; ADC Conversion Complete
;********************************************************************************
;	INT_VECTORS_SIZE	= 10	; size in words
;********************************************************************************

;******************************************
;   
;******************************************
KeyPress:
        in      KeyReg,PINB         ; 
        ori     KeyReg,keyMask      ;
        cp      KeyOld,KeyReg   ;   
        breq    KeySkip         ;  -    
        cpi     KeyReg,$FF          ;  
        breq    S_KeyOld            ;  
        sbrs    flag,keyNew     ;  ,   
        rjmp    KeyN_1              ;  

        sbi     PORTB,Lred
        sbi     PORTB,Lgreen        ; 

        sbis    PINB,kUp            ;   "Up"
        rjmp    KeyPressUp          ;    "UP"
        sbis    PINB,kDown          ;   "Up"
        rjmp    KeyPressDown        ;    "UP"
KeyN_1:         ;    
        sbr     flag,(1<<keyNew)     ;  -    
        cbr     flag,(1<<KeyEXE)     ;   
        ret
KeyPressUp:
        inc     PwmReg
        cpi     PwmReg,PwmConst ;  TOP
        brlo    Set_PWM
        ldi     PwmReg,PwmConst ; PWM
        cbi     PORTB,Lred      ;   
        rjmp    Set_PWM
KeyPressDown:
        dec     PwmReg
        breq    PC+2
        brge    Set_PWM
        clr     PwmReg          ;$00     PWM
        cbi     PORTB,Lgreen    ;   
Set_PWM:
        out     OCR0B,PwmReg    ; 
        cbr     flag,(1<<keyNew);   
S_KeyOld:
        cbr     flag,(1<<KeyEXE);   
        mov     KeyOld,KeyReg   ;  
KeySkip:ret
;******************************************
;    0
;******************************************
Tim0_OVF:
        in      tempSreg,SREG   ; 
        sbr     flag,(1<<KeyEXE);   
EndTmr0:
		out		SREG,tempSreg	; 
		reti	    			;  
;******************************************
begin:		;
        ldi     temp,RAMEND
        out     SPL,temp
        ldi     temp,(1<<Lred)|(1<<pwm)|(1<<Lgreen)
        out     DDRB,temp
        ldi     temp,(1<<Lred)|(1<<Lgreen)|(1<<kUp)|(1<<kDown)
        mov     KeyOld,temp
        out     PORTB,temp
IniTmr:
        ;ldi     temp,0b00110011     ;STS Top - OCR0A    set OC0A
        ldi     temp,0b00100011     ;STS Top - OCR0A    clr OC0A
        out     TCCR0A,temp
        ldi     temp,0b00001101     ;STS Top - OCR0A, clock=osc/1024
        ;ldi     temp,0b00001001     ;STS Top - OCR0A, clock=osc
        out     TCCR0B,temp
        ldi     PwmReg,PwmConst     ;187     PWM
        out     OCR0A,PwmReg
        ldi     PwmReg,StartConst   ; ()
        out     OCR0B,PwmReg
        ldi     temp,(1<<TOIE0)     ;  
        out     TIMSK0,temp
        sei                         ; 
mLoop:      ;  
sbrc    flag,KeyEXE     ;    
rcall   KeyPress        ; 

        rjmp    mLoop
